CREATE TABLE mod_phpwsrssfeeds_feeds (
    id                  INT NOT NULL DEFAULT '0',
    owner               VARCHAR(20) DEFAULT '',
    editor              VARCHAR(20) DEFAULT '',
    ip                  TEXT,
    label               TEXT NOT NULL,
    groups              TEXT,
    allow_view          TEXT,
    pm_allow            TEXT,
    channel_desc        TEXT,
    created             INT NOT NULL DEFAULT '0',
    updated             INT NOT NULL DEFAULT '0',
    hidden              SMALLINT NOT NULL DEFAULT '0',
    approved            SMALLINT NOT NULL DEFAULT '1',
    channel             TEXT NOT NULL,
    content             TEXT NOT NULL,
    footer              VARCHAR(60) NOT NULL DEFAULT '',
    show_title          SMALLINT NOT NULL DEFAULT '0',
    show_image          SMALLINT NOT NULL DEFAULT '0',
    show_url            SMALLINT NOT NULL DEFAULT '0',
    show_desc           SMALLINT NOT NULL DEFAULT '0',
    show_details        SMALLINT NOT NULL DEFAULT '0',
    cached              DATETIME NOT NULL DEFAULT '0000-00-00 00:00:00',
    home                SMALLINT NOT NULL DEFAULT '0',
    block               SMALLINT NOT NULL DEFAULT '0',
    target              VARCHAR(10) NOT NULL DEFAULT '_blank',
    expire              INT NOT NULL DEFAULT '60',
    max_items           INT NOT NULL DEFAULT '20',
    asc_desc            VARCHAR(10) NOT NULL DEFAULT 'ASC',
    orgn_by             VARCHAR(10) NOT NULL DEFAULT 'Default',
    days_ahead          VARCHAR(10) DEFAULT '0',
    show_expired        INT NOT NULL DEFAULT '1',
    empty_feed_msg      VARCHAR(60) DEFAULT 'Feed Contains No Content',
    PRIMARY KEY (id)
);

CREATE TABLE mod_phpwsrssfeeds_backend (
    id                  INT NOT NULL DEFAULT '0',
    owner               VARCHAR(20) DEFAULT '',
    editor              VARCHAR(20) DEFAULT '',
    ip                  TEXT,
    label               TEXT NOT NULL,
    groups              TEXT,
    created             INT NOT NULL DEFAULT '0',
    updated             INT NOT NULL DEFAULT '0',
    hidden              SMALLINT NOT NULL DEFAULT '0',
    approved            SMALLINT NOT NULL DEFAULT '1',
    numitems            SMALLINT NULL,
    type                TEXT,
    description         TEXT,
    image               TEXT,
    PRIMARY KEY (id)
);
CREATE TABLE mod_phpwsrssfeeds_multi (
    id                  INT NOT NULL DEFAULT '0',
    owner               VARCHAR(20) DEFAULT '',
    editor              VARCHAR(20) DEFAULT '',
    ip                  TEXT,
    label               TEXT NOT NULL,
    groups              TEXT,
    created             INT NOT NULL DEFAULT '0',
    updated             INT NOT NULL DEFAULT '0',
    hidden              SMALLINT NOT NULL DEFAULT '0',
    approved            SMALLINT NOT NULL DEFAULT '1',
    show_in_multiview   TEXT,
    max_multi_items     INT NOT NULL DEFAULT '20',
    home                SMALLINT NOT NULL DEFAULT '0',
    block               SMALLINT NOT NULL DEFAULT '0',
    allow_view          TEXT,
    pm_allow            TEXT,
    show_empty_feeds    SMALLINT NOT NULL DEFAULT '1',
    show_anchor_links   SMALLINT NOT NULL DEFAULT '1',
    show_cat_link       SMALLINT NOT NULL DEFAULT '1',
    sort_order          TEXT,
    PRIMARY KEY (id)
);
CREATE TABLE mod_phpwsrssfeeds_aggregate (
    id                  INT NOT NULL DEFAULT '0',
    owner               VARCHAR(20) DEFAULT '',
    editor              VARCHAR(20) DEFAULT '',
    ip                  TEXT,
    label               TEXT NOT NULL,
    groups              TEXT,
    created             INT NOT NULL DEFAULT '0',
    updated             INT NOT NULL DEFAULT '0',
    hidden              SMALLINT NOT NULL DEFAULT '0',
    approved            SMALLINT NOT NULL DEFAULT '1',
    home                SMALLINT NOT NULL DEFAULT '0',
    block               SMALLINT NOT NULL DEFAULT '0',
    allow_view          TEXT,
    pm_allow            TEXT,
    show_in_aggregate   TEXT,
    type                VARCHAR(20) NOT NULL DEFAULT 'Date',
    asc_desc            VARCHAR(20) NOT NULL DEFAULT 'ASC',
    PRIMARY KEY (id)
);
